#This file is part of Tryton.  The COPYRIGHT file at the top level of
#this repository contains the full copyright notices and license terms.
from trytond.model import ModelView, ModelSQL, fields
import datetime


class Inventory(ModelSQL, ModelView):
    _name = 'stock.inventory'

    def __init__(self):
        super(Inventory, self).__init__()
        self._error_messages.update({
            'confirm_with_sale_import_journal':
                    'You can not confirm inventory ' \
                    'when there is still a draft sale import journal!',
            })

    def set_state_done(self, cursor, user, inventory_id, context=None):
        journal_obj = self.pool.get('sale_import.journal')
        date_obj = self.pool.get('ir.date')

        inventory = self.browse(cursor, user, inventory_id, context=context)
        if journal_obj.search(cursor, user, [
            ('date', '<=', date_obj.today(cursor, user, context=context)),
            ('company', '=', inventory.company.id),
            ('profit_center.storage_location', '=',
                inventory.location.id),
            ('state', '=', 'draft'),
            ], context=context):
            self.raise_user_error(cursor,
                    'confirm_with_sale_import_journal',
                    context=context)
        return super(Inventory, self).set_state_done(
                cursor, user, inventory_id, context=context)

Inventory()
